
C **************************************************
C
C   SUBROUTINE EWINIT
C(FUNCTION)
C   INITIALIZE CONSTANTS FOR EW THEORY
C(OUTPUT)
C   TO COMMON /EWCONS/
C
C ***************************************************
C
      SUBROUTINE EWINIT
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 EWPARA(50)
      COMMON /EWCONS/ EWPARA
      SAVE    EWCONS
 
C
C
      EWPARA( 1) = DACOS(-1.D0)
      EWPARA( 2) = 2*EWPARA(1)
      EWPARA( 3) = 0.38937966D12
      EWPARA( 4) = 1./137.035989D0
      EWPARA( 5) = 1./128.0D0
      EWPARA( 6) = 0.23D0
      EWPARA( 7) = 1.D0 - EWPARA(6)
      EWPARA( 8) = DSQRT(EWPARA(6))
      EWPARA( 9) = DSQRT(EWPARA(7))
 
      EWPARA(11) = 91.170D0
      EWPARA(12) = 2.5D0
      EWPARA(13) = DSQRT(EWPARA(7)*EWPARA(11)**2)
      EWPARA(14) = 2.0D0
      EWPARA(15) = 100.D0
      EWPARA(16) = 150.D0
 
      EWPARA(21) = 4.D0*EWPARA(1)*EWPARA( 5)
      EWPARA(22) = DSQRT(EWPARA(21))
      EWPARA(23) = EWPARA(22)/EWPARA(8)
      EWPARA(24) = EWPARA(23)/EWPARA(9)
 
      EWPARA(31) =  0.25D0
      EWPARA(32) = -0.25D0
      EWPARA(33) = -0.25D0 + EWPARA( 6)
      EWPARA(34) =  0.25D0
      EWPARA(35) =  0.25 - 2./3.*EWPARA( 6)
      EWPARA(36) = -0.25D0
      EWPARA(37) = -0.25D0 + 1./3.*EWPARA( 6)
      EWPARA(38) = 0.25D0
 
      RETURN
      END
