CINCLUDE SGZHNP
CINCLUDE UHCUPL
CINCLUDE AMPZH
C*  Total cross section for e+e- --> ZH.
C*    RS = sqrt(s)
C*
      DATA LOUNIT / 20 /
C--
C  Differential cross section.
C--
      WRITE(LOUNIT,'(''SET FONT DUPLEX'')')
      WRITE(LOUNIT,'(''NEW FRAME'')')
      WRITE(LOUNIT,'(''SET WINDOW X 2 12 Y 1.8 9.2'')')
      WRITE(LOUNIT,'(''SET LIMITS X 100. 1500.0 Y 0.1 1000.'')')
      WRITE(LOUNIT,'(''SET SCALE Y LOGARITHMIC'')')
      WRITE(LOUNIT,'(''SET LABELS SIZE 2.5'')')
      WRITE(LOUNIT,'(''SET TITLE  SIZE 3.0'')')
      WRITE(LOUNIT,'(''TITLE   6. 8.5 SIZE 3.0'',
     .            '' '''' e2+3e2-3 --> ZH: solid'')')
      WRITE(LOUNIT,'(''CASE                   '',
     .            '' ''''  X X X X        '')')
      WRITE(LOUNIT,'(''TITLE   6. 8.0 SIZE 3.0'',
     .            '' '''' e2+3e2-3 --> ZZ: dash '')')
      WRITE(LOUNIT,'(''CASE                   '',
     .            '' ''''  X X X X        '')')
      WRITE(LOUNIT,'(''TITLE .25 5. ANGLE 90 SIZE 4 ''''S0tot1(fb)'')')
      WRITE(LOUNIT,'(''CASE                         ''''GX   X    '')')
      WRITE(LOUNIT,'(''TITLE 6.5 0.8 SIZE 4 ''''2s0O (GeV)'')')
      WRITE(LOUNIT,'(''CASE                 ''''M UD      '')')
      WRITE(LOUNIT,'(''SET ORDER X Y '')')
C--
      YMN  = -1
      YMX  =  1
      NY   =  40
      DY   = (YMX-YMN)/NY
C--
      NRS  =  100
C--
      UNIT = 1000
      AMZ  = 91.19
      AMMN = 150.
      AMMX = 300.
      NAM  = 1
      DAM  = (AMMX-AMMN)/NAM
      DO 1000 IAM = 0, NAM
         AMH = AMMN + IAM*DAM
         WRITE(LOUNIT,'(''( AMH = '',F10.2,'' GeV'')') AMH
C--
         RSMN =  AMZ + AMH + 0.00001
         DO 100 IRS = 0, NRS
            IF ( IRS.LE.20 ) THEN
               DRS  = 1
            ELSE
               RSMN = AMZ + AMH + 30 - 400
               DRS  = 20
            ENDIF
            RS = RSMN + IRS*DRS
            SGT = 0
            DO 10 IY = 0, NY
               Y = YMN + IY*DY
               IF ( IY.EQ.0 .OR. IY.EQ.NY ) THEN
                  WT = 1
               ELSE IF ( MOD(IY,2).EQ.0 ) THEN
                  WT = 2
               ELSE
                  WT = 4
               ENDIF
               CALL SGZHNP(RS,AMH,Y,SG)
               SGT = SGT + WT*SG
10          CONTINUE
            SGT = SGT*DY/3
            WRITE(LOUNIT,'(2F15.5)') RS, SGT*UNIT
100      CONTINUE
         WRITE(LOUNIT,'(''JOIN'')')
1000  CONTINUE
      PRINT *, '(END)'
C--
      STOP
      END
