CINCLUDE HIOKI
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8   WMASS(5)
C
C========< Entry Point >================================================
C
C--
C  Initialize particle masses.
C--
      CALL INIMAS
      AMZ   =  91.19D0
C--
C     AMTMN = 144.5D0
C     AMTMX = 145.5D0
C     AMTMN = 131.5D0
C     AMTMX = 132.5D0
C     NMT   = 2
      AMTMN = 150.0D0
      AMTMX = 190.0D0
      NMT   = 8
      DMT   = (AMTMX-AMTMN)/NMT
C--
      AMHMN = 50.D0
      AMHMX = 1000.D0
      NMH   = 50
      DMH   = (AMHMX-AMHMN)/NMH
C--
      CALL ZHWMAS( DR, WMASS, AMZ, AMTMN, AMHMX )
C      AMWMN  =  WMASS(1)
      AMWMN  =  WMASS(4)
      CALL ZHWMAS( DR, WMASS, AMZ, AMTMX, AMHMN )
C      AMWMX  =  WMASS(1)
      AMWMX  =  WMASS(4)
C--
      WRITE(20,'(''NEW FRAME      '')')
      WRITE(20,'(''SET FONT DUPLEX'')')
      WRITE(20,'(''(              '')')
      WRITE(20,'(''SET WINDOW X 3 12 Y 2 9'')')
      WRITE(20,'(''SET LIMIT X '',2E12.5)') AMWMN, AMWMX
      WRITE(20,'(''SET LIMIT Y '',2E12.5)') AMHMN, AMHMX
      WRITE(20,'(''SET SCALE Y LOG'')')
      WRITE(20,'(''SET LABELS SIZE 3'')')
      WRITE(20,'(''(              '')')
      WRITE(20,'(''TITLE 6.5 1 SIZE 4 ''''M0W1 (GeV)             '')')
      WRITE(20,'(''CASE              '''' X X                    '')')
      WRITE(20,'(''TITLE  1.4 4.5 ANGLE 90  SIZE 4 ''''M0H1 (GeV)'')')
      WRITE(20,'(''CASE                            '''' X X      '')')
      WRITE(20,'(''(              '')')
      WRITE(20,'(''TITLE 9.2 8.5 SIZE 3 ''''M0Z1='',1F5.2,''GeV'')') AMZ
      WRITE(20,'(''CASE                 '''' X X         '')')
C--
      DO 100 IMT = 0, NMT
         AMT = AMTMN + IMT*DMT
         WRITE(20,'(''( m_t = '',F8.2,'' GeV'')') AMT
         WRITE(20,'(''SET ORDER Y X'')')
         DO 10 IMH = 0, NMH
            AMH = AMHMN + IMH*DMH
            CALL ZHWMAS( DR, WMASS, AMZ, AMT, AMH )
C           AMW  =  WMASS(1)
            AMW  =  WMASS(4)
            WRITE(20,'(2F15.3)') AMH, AMW
            IF ( IMH.EQ.NMH/5 ) THEN
               AMHS = AMH
               AMWS = AMW
            ENDIF
10       CONTINUE
         WRITE(20,'(''JOIN SOLID'')')
         WRITE(20,'(''TITLE '',2E12.5,'' DATA SIZE 2 '''''',I3)')
     .                AMWS-0.025, AMHS, INT(AMT)
100   CONTINUE
C--
      WRITE(20,'(''TITLE '',2E12.5,'' DATA SIZE 2.5 ''''m0t1 = '')')
     .                80.12, AMHS
      WRITE(20,'(''CASE                             '''' X X   '')')
      PRINT *, '(END)'
C--
C  That's it.
C--
      STOP
      END
