      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8   WMASS(5)
C
C========< Entry Point >================================================
C
C--
C  Initialize particle masses.
C--
      AMZ   =  91.19D0
C--
      AMTMN = 100.D0
      AMTMX = 200.D0
      NMT   = 100
      DMT   = (AMTMX-AMTMN)/NMT
C--
      AMHMN = 100.D0
      AMHMX = 1000.D0
      NMH   = 9
      DMH   = (AMHMX-AMHMN)/NMH
C--
      WRITE(20,'(''SET LIMITS X 79.7 80.7 Y 100 200'')')
      DO 100 IMH = 0, NMH
         AMH = AMHMN + IMH*DMH
         WRITE(20,'(''( M_H = '',F8.2,'' GeV'')') AMH
         WRITE(20,'(''SET ORDER Y X'')')
         DO 10 IMT = 0, NMT
            AMT = AMTMN + IMT*DMT
            CALL ZHWMAS( DR, WMASS, AMZ, AMT, AMH )
C           AMW  =  WMASS(1)
            AMW  =  WMASS(4)
            WRITE(20,'(2F15.3)') AMT, AMW
10       CONTINUE
         WRITE(20,'(''JOIN SOLID'')')
100   CONTINUE
      PRINT *, '(END)'
C--
C  That's it.
C--
      STOP
      END
