 
      SUBROUTINE TTWWNP(AMZ,GMZ,AMW,GMW,
     .                  C0,CV,CA,CWWZ,CW,
     .                  P1P2,P1Q1,TTA)
 
      IMPLICIT REAL*8  ( A-H, O-Z )
C--
C  Statement functions.
C--
      RBW(A,B) =  A-B*B
      BW2(A,B) = (A-B*B)**2+B*B*GMZ*GMZ
C--
C  Ddifferential cross section is given by the follwing.
C     d(sigma)/d(omega) = TTA*(e**2/(sin2w*cos2w))**2*BT/(64*xPI**2*S)
C                       = TTA*(xALF**2/(sin2w*cos2w))**2*BT/(4*S)
C  REDUCE output here.
C--
      TTAGG=C0**4*(-3.*AMW**6*P1P2-6.*AMW**4*P1Q1**2+6.*AMW**4*
     .      P1Q1*P1P2-6.*AMW**4*P1P2**2+4.*AMW**2*P1Q1**2*P1P2-4.*AMW
     .      **2*P1Q1*P1P2**2+3.*AMW**2*P1P2**3-2.*P1Q1**2*P1P2**2+2.*
     .      P1Q1*P1P2**3)/(AMW**4*P1P2**2)
      TTATT=8.*CW**4*(-AMW**6*P1P2-10.*AMW**4*P1Q1**2-2.*AMW**4*
     .      P1Q1*P1P2+8.*AMW**2*P1Q1**3+4.*AMW**2*P1Q1**2*P1P2-8.*
     .      P1Q1**4+8.*P1Q1**3*P1P2)/(AMW**8-4.*AMW**6*P1Q1+4.*AMW**4
     .      *P1Q1**2)
      TTAZG=4.*C0**2*CV*CWWZ*(3.*AMW**6*P1P2+6.*AMW**4*P1Q1**2-
     .      6.*AMW**4*P1Q1*P1P2+6.*AMW**4*P1P2**2-4.*AMW**2*P1Q1**2*
     .      P1P2+4.*AMW**2*P1Q1*P1P2**2-3.*AMW**2*P1P2**3+2.*P1Q1**2*
     .      P1P2**2-2.*P1Q1*P1P2**3)/(2.*AMW**4*P1P2**2-AMW**4*P1P2*
     .      AMZ**2)
      TTAGT=4.*C0**2*CW**2*(-3.*AMW**6*P1P2-6.*AMW**4*P1Q1**2-3.
     .      *AMW**4*P1P2**2+4.*AMW**2*P1Q1**3-2.*AMW**2*P1Q1**2*P1P2+
     .      4.*AMW**2*P1Q1*P1P2**2-4.*P1Q1**3*P1P2+4.*P1Q1**2*P1P2**2)
     .      /(AMW**6*P1P2-2.*AMW**4*P1Q1*P1P2)
      TTAZZ=4.*(CV**2+CA**2)*CWWZ**2*(-3.*AMW**6*P1P2-6.*AMW**4*P1Q1**2+
     .      6.*AMW**4*P1Q1*P1P2-6.*AMW**4*P1P2**2+4.*AMW**2*P1Q1**2*
     .      P1P2-4.*AMW**2*P1Q1*P1P2**2+3.*AMW**2*P1P2**3-2.*P1Q1**2*
     .      P1P2**2+2.*P1Q1*P1P2**3)/(4.*AMW**4*P1P2**2-4.*AMW**4*
     .      P1P2*AMZ**2+AMW**4*AMZ**4)
      TTAZT=8.*(CV-CA)*CW**2*CWWZ*(3.*AMW**6*P1P2+6.*AMW**4*P1Q1**2+
     .      3.*AMW**4*P1P2**2-4.*AMW**2*P1Q1**3+2.*AMW**2*P1Q1**2*P1P2
     .      -4.*AMW**2*P1Q1*P1P2**2+4.*P1Q1**3*P1P2-4.*P1Q1**2*P1P2**2)
     .      /(2.*AMW**6*P1P2-AMW**6*AMZ**2-4.*AMW**4*P1Q1*P1P2+2.*
     .      AMW**4*P1Q1*AMZ**2)
      TTA = TTAZZ + TTAGG + TTATT + TTAZG + TTAZT + TTAGT
C--
C  That's it.
C--
      RETURN
      END
