      PROGRAM PLTBST
C*
C*  This routine draws the best fit curve.
C*
      IMPLICIT    REAL*8 ( A-H, O-Z )
      PARAMETER   ( NA = 3 )
      REAL*8      A(0:NA)
      DATA LOU /20/
      DATA SG     / 1.D0 /
C--
C  Statement function.
C--
      GL(E,SG) = DERFC(-E/SG/SQRT(2.D0))/2
      GH(E,SG) = DERFC( E/SG/SQRT(2.D0))/2
C
C==================< Entry Point >======================================
C
C--
C  Initialization.
C--
      EP = 175.
      CALL GTCHI2(0,EP,SG,AMP,AMD,NP,A,CHI2)
C--
C  Calculate chi**2.
C--
CT    AMP = 141.89
CT    AMD = 117.78
C--
      AMP = 142.1
      AMD = 118.1
C--
      CALL GTCHI2(1,EP,SG,AMP,AMD,NP,A,CHI2)
      FUNC = CHI2
      PRINT *, ' NP = ', NP, ' CHI2 = ', CHI2
      PRINT *, ' A  = ', A
C--
C  Prepare topdraw data.
C--
      CALL ELBXT2(EP,AMP,AMD,EMIN,EMAX)
      NE = 50
      EL = EMIN - 5
      EH = EMAX + 5
      DE = (EH-EL)/NE
      WRITE(LOU,*) 'SET ORDER X Y'
      DO 30 IE = 0, NE
         E = EL + IE*DE
         F = A(NA)
         DO 3 IA = NA-1, 0, -1
            F = F*E + A(IA)
3        CONTINUE
         F    = F*GL(E-EMIN,SG)*GH(E-EMAX,SG)
         WRITE(LOU,*) E, F
30    CONTINUE
      WRITE(LOU,*) 'JOIN'
C--
C  That's it.
C--
      STOP
      END
