      implicit real*8(a-h,m-z)
      common /call/ icall
      icall=0.d0
      write(*,*) 'mstau,mchi,ptau,xsig'
      read(*,*) mstau,mchi,ptau,xsig
      chi2=ezfit(mstau,mchi,ptau,xsig)
      write(*,*) chi2
      end
      real*8 function ezfit(mstau,mchi,ptau,xsig)
      implicit real*8(a-h,m-z)
      dimension ez(-1:25,100)
      common /call/ icall
C     if icall=0 program calculate the distribution 
C     of polarized rho in the thzdis called in ezdis
C     and also read the sg  background  and fitted bg event 
C     inside chi2. the icall will be set to be 1. 
C     unless icall set to be 0 again, program does not 
C     calculate the those numbers again. 
C
C     xsig is number of stau pair produced, nubmer you want to fit
C     number of acceptance 
C      for 0.08<z<0.92
      acp=14043.d0/100000.d0
      acm=16563.d0/100000.d0
C      for 0.08<z<0.92 ej>20
C      acp=10525.d0/100000.d0
C      acm=10866.d0/100000.d0
C      no cut
C      acp=17428.d0/100000.d0
C      acm=17348.d0/100000.d0
C 
C      number of rho event you use for your fit
      event=(ptau+1.d0)/2.d0*acp*xsig+(ptau-1.d0)/2.d0*acm*xsig
      call ezdis(mstau,mchi,ptau,ez)
      call chi2(ez,event,ezfit)
      return 
      end
C############################################################
C     subrouitne to evaluate chi from given ejet-zc distrubtion ez(z,ejet)
      subroutine chi2(ez,event,chi)
      implicit real*8(a-h,m,o-z)
      common /call/ icall   
      character*80  input
C     for icall.eq.1, the program call signal and bg from data file 
C     number, which is calcuated from total number of signal 
      dimension bg_fit(25,100),bg(25,100),sg(25,100),ez(-1:25,100)
      save bg_fit, bg, sg
C      ecut
      necut=1
      if(icall.eq.0) then 
      open(11,file='bg.ez')
      open(12,file='p+1.10^5.ez')
      open(21,file='out.lis')
          do 11 j=1,37
          ejet=4.d0*j-2.d0
          do 10 i=1,25
             zc=0.04*i-0.02
C fitted background
             call ezbgfit(ejet,zc,xbg)
             bg_fit(i,j) =xbg
C mc of bg for 100fb-1
             read(11,*) x, bg(i,j)
C mc of sg for 100 fb-1
2000	     read(12,'(A80)') input
	     if ( input(2:2).ne.'(' .and. input(1:2).ne.'  ' ) then
	        read(input,*) x, sg(i,j)
C             read(12,*)  x,sg(i,j)
C             write(21,*) x,sg(i,j),bg(i,j), bg_fit(i,j)
              write(21,*) x,sg(i,j)
             else
              go to 2000
	     endif
C use the event from i from 3 to 23 only  
 10       continue
 11       continue
      close(11)
      close(12)
      close(21)
      endif
      icall=1
C    for icall=1 use this  only
      ezsum=0.d0
      do 12 j=necut,37
      do 13 i=3,23
        ezsum=ez(i,j)+ezsum
 13   continue
 12   continue
      fac=event/ezsum
      chi=0.d0
      do 14 j=necut,37
      do 15 i=3,23
        mu=fac*ez(i,j)+bg_fit(i,j)
        xn=sg(i,j)+bg(i,j)   
        chi=chi-2.d0*xllike(xn,mu)
 15   continue
 14   continue
      return 
      end
C
C    fit of Ejet zc distributon of background for 100 fb 
C    binsize 4 GeV from ejet=0
C    binsize 0.04  from zc=0.08 to 0.92
      subroutine ezbgfit(ejet,z,bg)
      implicit real*8(a-h,m,o-z)
C    fitebg is energy distribution.
      x=ejet/10.d0
        fitebg=-1.2611d0 +1.0250d1*x -0.46362d1*x**2
     &   +0.88406*x**3
     &   -0.84997d-1*x**4+0.40657d-2*x**5-0.77053d-4*x**6
C
C total of the background coming from this e distribution
        fac=90.677131134
C
C        xbfit=1.5686d0 + 7.8659d0*x - 7.7216d0*x*x
C  xbfit is a fit of signal of z dis from 0.08 to 0.92 e>0GeV. 
C  the one for e.20 GeV(above is consistent to this.
C  total is about 87 events.( Do not use this distibution for the event 
C out of  0.08<z<0.92
C
        xbfit=2.0953+9.0665*z-8.3747*z*z
        bg=fitebg/fac*xbfit
        end

        real*8 function xllike(xn,mu)
        implicit real*8(a-h,m,o-z)
        xxnchi=xnchi(xn)
        xllike=xn*log(mu)-mu-xxnchi
        end
C       xn observed number of event in a bin
C       prob to observe the number of event in the bin
        

        real*8 function xnchi(xn)
        implicit real*8(a-h,m,o-z)
        if(xn.eq.0.d0) then 
        xnchi=0.d0
        elseif(xn.lt.10) then
        sum=0.d0
        x=xn
        do 1 i=1,10
        sum=sum+log(x)
        x=x-1.d0
        if(x.le.1.d0)  goto 3
 1      continue
 3      continue
        xnchi=sum
        else
        pi=2.d0*asin(1.d0)
        xnchi=0.5d0*log(2.d0*pi)-0.5d0 -(xn+1.d0)-log(xn+1.d0)
     &  +((xn+1)*0.5d0+0.25d0)*(log(xn+1)+log(xn+2))
     &  +1.d0/12.d0*log((xn+2.d0)/(xn+1.d0))
        endif
        end


      subroutine ezdis(mstau0,mchi0,ptau,ez)
      implicit real*8(a-h,m-z)
      parameter (zmin =0.344977d-1)
      common /ypara/ y
      common /beam/ roots0, del
      common /kinstau/ xmax,xmin,vstau
      common /masses/ mstau,mchi,mtau
C      common /idummy/ iyx
      dimension sum(4)
      dimension ftr(4,0:250), yzah(0:250)
      dimension ez(-1:25,100)
C     in the beginning ez(-1,i) contains energy distribution 
C     and ez(0,i) contains polarization of rho in the bin. 
C     the the program calculate the z distibution and store 
C     it in the the second col.
      external   gtrrt,gtrrl,gtlrt, gtlrl
C           sum(1)  t_R to rho_T
C           sum(2)  t_R to rho_L
C           sum(3)  t_L to rho_T
C           sum(4)  t_L to rho_L
C       edis=(ptau+1)(sum1+sum2)/2.d0+(-ptau+1)(sum3+sum4)/2.d0
C       prho=[sum4(1-ptau)+sum2(1+ptau)-sum3(1-ptau)-sum1(ptau+1)]/edis
C
CC
C
C     This program calculates polarization for fixed mstau,mchi. 
C     sum of  tau_LR goes into rho_LR.
C     and polarization in each energy bin for t and l component.
C     x is tau energy distribution 
C     y is jet energy distribution
      iwrite=0
      mstau=mstau0
      mchi=mchi0
C     input bin size in GeV
      bin=4.d0
C    input number of event you want to normarize
C    normarize total number of event as 1
C      
C parameters
       eps=0.001
       mtau=1.78d0
 1000  continue
       roots0=500.d0
       del=500.d0*0.005d0
       roots=roots0+del
C kinematical paramters
       vstau=dsqrt(1.d0-(2.d0*mstau/roots)**2)
       etauc=(mstau**2+mtau**2-mchi**2)/2.d0/mstau
       ptauc=dsqrt(etauc**2-mtau**2)
       etaumax=(etauc+ptauc*vstau)/dsqrt(1.d0-vstau**2)
       etaumin=(etauc-ptauc*vstau)/dsqrt(1.d0-vstau**2)
C       write(1,*) 'etaumax,etaumin',etaumax,etaumin
C max and min tau energy normarized by beam energy
       xmax=2.d0*etaumax/roots
       xmin=2.d0*etaumin/roots
C       write(1,*) 'xmin,xmax',xmin,xmax
C----
      xx=0.d0
      xxx=0.d0
      call beamset(xx,xxx,0)
      fac=1.d0/0.23d0
C---
C   do loop for y ( rho energy normarized by beem energy).
       ymax=xmax
C---
C   bin size in y
C---
       dely=bin/roots*2.d0
C       write(1,*) 'bin=',bin,'GeV, dely=',dely
C---
C   max bin number iny
C---
       iny=int(xmax/dely)+1
C       write(1,*) iny
C--- initialization for total number 
       totall=0.d0
       totalt=0.d0
C calculate distribution of transverse and logtitutenal for each dely/4.d0
       do 10 iy=1,4*iny       
C       iyx=iy
       y=iy*dely/4.d0
       zminx=max(zmin,y/xmax)
       zmaxx=min(1.d0,y/xmin)
C
       if(y.lt.xmax) then 
C   tau_R to rho_T
C       get qmin, qmax
          call tr2rt(qmin,zminx,2)
          call tr2rt(qmax,zmaxx,2)
C       integrate 
          call simp(gtrrt,qmin,qmax,ftr(1,iy),eps,ifail)
C   tau_R to rho_L
          call tr2rl(qmin,zminx,2)
          call tr2rl(qmax,zmaxx,2)
          call simp(gtrrl,qmin,qmax,ftr(2,iy),eps,ifail)
C   tau_L to rho_T
          call tl2rt(qmin,zminx,2)
          call tl2rt(qmax,zmaxx,2)
          call simp(gtlrt,qmin,qmax,ftr(3,iy),eps,ifail)
C   tau_L to rho_L
          call tl2rl(qmin,zminx,2)
          call tl2rl(qmax,zmaxx,2)
          call simp(gtlrl,qmin,qmax,ftr(4,iy),eps,ifail)         
       else
          ftr(1,iy) = 0.d0
          ftr(2,iy) = 0.d0
          ftr(3,iy) = 0.d0
          ftr(4,iy) = 0.d0

       endif
C output for check
C
C       write(*,*) y,ftr(1,iy),ftr(2,iy),ftr(3,iy),ftr(4,iy)
 333   format(e11.4,1x,e11.4,1x,e11.4,1x,e11.4,1x,e11.4)
       yzah(iy)=y
 10    continue
C
C calculate total number of event in the bin dely
       yzah(0) = 0.d0
       ftr(1,0) = 0.d0
       ftr(2,0) = 0.d0
       ftr(3,0) = 0.d0
       ftr(4,0) = 0.d0
       do 20 iyd=1,iny
       iy=4*(iyd-1)
       do 30 icase=1,4
         fa=ftr(icase,iy)
         ya=yzah(iy)
         fb=ftr(icase,iy+1)
         yb=yzah(iy+1)
         fc=ftr(icase,iy+2)
         yc=yzah(iy+2)
       call binval(fa,fb,fc,ya,yb,yc,xsum1)
         fa=ftr(icase,iy+2)
         ya=yzah(iy+2)
         fb=ftr(icase,iy+3)
         yb=yzah(iy+3)
         fc=ftr(icase,iy+4)
         yc=yzah(iy+4)
       call binval(fa,fb,fc,ya,yb,yc,xsum2)
         fa = ftr(icase,iy)
         ya = yzah(iy)
         fb = ftr(icase,iy+2)
         yb = yzah(iy+2)
         fc = ftr(icase,iy+4)
         yc = yzah(iy+4)
       call binval(fa,fb,fc,ya,yb,yc,xsum0)
C       write(*,*) xsum
        sum(icase)=xsum1 + xsum2
        error=( xsum0 - xsum1 - xsum2)/(xsum1 + xsum2)
        error=abs(error)
C WARNING NEED ICHECK FLAG TO SUPRESS OUTPUT 
        if(error.gt.0.1) write(*,*) 'error',iyd,icase,sum(icase),error
 30   continue
C       edis=(ptau+1)(sum1+sum2)/2.d0+(-ptau+1)(sum3+sum4)/2.d0
C       prho=[sum4(1-ptau)+sum2(1+ptau)-sum3(1-ptau)-sum1(ptau+1)]/edis
        ez(-1,iyd) = (ptau + 1.d0)*( sum(1) + sum(2) )/2.d0
     &             + ( -ptau + 1.d0)* (sum(3)+sum(4))/2.d0
        ez(0,iyd)= ( sum(4)*(1.d0 - ptau) + sum(2)*(1.d0 + ptau)
     &         -sum(3)*(1.d0 - ptau) -sum(1)*(ptau+1.d0) )
     &                      /ez(-1,iyd)/2.d0
C       write(*,*) ez(-1,iyd),ez(0,iyd)
 20   continue
C      now program calculates z distribution according to ez(iyd,0)
       do 40 i=1,iny
          call thzdis(ez(-1,i))
 40    continue
C
C output for check
C     
       if(iwrite.eq.1) then
       open(20,file='check2.lis')
       do 50 j=1,37
       do 60 i=1,25 
       write(20,*) j, i,ez(i,j)
 60    continue
 50    continue
       close(20)
       endif
       return
       end
C

       subroutine thzdis(ez)
       implicit real*8(a-h,m,o-z)
       dimension ez(-1:25),thl(25),tht(25)
       common /call/ icall
       common /beta/ btpi,btrho
       common /mami/ xmax,xmin
        external fl,ft
       save thl,tht
       xnorm=ez(-1)
       prho=ez(0)
C   if icall=0, program calculates z-distribution for 
C   trans and logtitudenaly polarized rho respectively
       if(icall.eq.0) then 
       binsize=0.04
       mpi=0.14d0
       mrho=0.77d0
       btpi=dsqrt(1.d0-4.d0*mpi**2/mrho**2)
       btrho=1.d0    ! we have neglected betarho dependence so far. 
       xmin=(1.d0 - btpi*btrho)/2.d0
       xmax=(1.d0 + btpi*btrho)/2.d0
       eps=0.001
       call simp2(fl,xmin,xmax,suml,eps,ifail)
       call simp2(ft,xmin,xmax,sumt,eps,ifail)
       do 1 i=1,25
         mibin=(i-1)*binsize
         maxbin=i*binsize
         if(mibin.ge.xmin.and.maxbin.le.xmax) then 
           call simp2(fl,mibin,maxbin,xsuml,eps,ifail) 
           call simp2(ft,mibin,maxbin,xsumt,eps,ifail)
         else
                if(mibin.lt.xmin.and.maxbin.le.xmin) then 
                xsuml=0.d0
                xsumt=0.d0
                elseif(mibin.ge.xmax.and.maxbin.gt.xmax) then
                xsuml=0.d0
                xsumt=0.d0
                else
                mibin=max(xmin,mibin)
                maxbin=min(xmax,maxbin)
                call simp2(fl,mibin,maxbin,xsuml,eps,ifail)
                call simp2(ft,mibin,maxbin,xsumt,eps,ifail)
                endif
        endif
        thl(i)=xsuml/suml
        tht(i)=xsumt/sumt
 1      continue
      endif
      do 2 i=1,25
        ez(i)=xnorm*( thl(i)*(prho+1.d0)+(1.d0-prho)*tht(i))/2.d0
 2    continue      
      return
      end
         real*8 function fl(x)
        implicit real*8(a-h,l-z)
         common /beta/ btpi,btrho
         common /mami/ xmax,xmin
         if(x.gt.xmax.or.x.lt.xmin) then 
         fl=0.d0
         else
         fl=(2.d0*x-1.d0)**2/btpi**3/btrho**3*3.d0
         endif
         end
         real*8 function ft(x)
        implicit real*8(a-h,l-z)
         common /beta/ btpi,btrho
         common /mami/ xmax,xmin
         if(x.gt.xmax.or.x.lt.xmin) then 
         ft=0.d0
         else
         ft=(btpi**2*btrho**2-(2.d0*x-1.d0)**2)/btpi**3/btrho**3
     &  *1.5d0
         endif
         end


      real*8 function gtrrt(q)
C Integration of this function by q( which is integrated z distribtuion) 
C gives number of event at value y( fractional rho energy) for 
C tau_R--> rho_T
      implicit real*8(a-h,m-z)
      common /ypara/ y
C--
C   q---> z
C--
      call tr2rt(q,z,1)
C      write(*,*) 'from gtrrt, z=', z
      x=y/z
C      write(*,*) 'corresponding x=',x 
      call beamset(x,fac,1)
C      write(*,*) 'fac', fac
      gtrrt=fac/z
      end
C
C
      real*8 function gtrrl(q)
C  tau_R to rho_L
      implicit real*8(a-h,m-z)
      common /ypara/ y
C   q---> z
      call tr2rl(q,z,1)
      x=y/z
      call beamset(x,fac,1)
      gtrrl=fac/z
      end
C
C
      real*8 function gtlrt(q)
C  tau_R to rho_T
      implicit real*8(a-h,m-z)
      common /ypara/ y
C   q---> z
      call tl2rt(q,z,1)
      x=y/z
      call beamset(x,fac,1)
      gtlrt=fac/z
      end
C
C
      real*8 function gtlrl(q)
C   tau_L to rho_L
      implicit real*8(a-h,m-z)
      common /ypara/ y
C   q---> z
      call tl2rl(q,z,1)
      x=y/z
      call beamset(x,fac,1)
      gtlrl=fac/z
      end
C       
C
       subroutine binval(fa,fb,fc,ya,yb,yc,sum)
       implicit real*8(a-h,m-z)
       faca=1.d0/(ya-yb)/(ya-yc)
       facb=1.d0/(yb-ya)/(yb-yc)
       facc=1.d0/(yc-ya)/(yc-yb)
       b=-fa*faca*(yb+yc)-fb*facb*(ya+yc)-fc*facc*(ya+yb)
       a=fa*faca+fb*facb+fc*facc
       c=fa*faca*yb*yc+fb*facb*ya*yc+fc*facc*ya*yb
       sum=a/3.d0*(yc**3-ya**3)+b/2.d0*(yc**2-ya**2)
     & +c*(yc-ya)
       return
       end































