C***********************************************************************
C*
C*====================
C* Subroutine PRUJTM
C*====================
C*
C* (Purpose)
C*    Job termination for user analysis.
C* (Input & Output )
C*    none.
C* (Relation)
C*    Called by FLANLI
C* (Update Record)
C*   95/03/06  K.Fujii		Orignal version.
C*   95/03/16  K.Fujii		Modified to use PRUCOM.
C*
C***********************************************************************
 
      SUBROUTINE PRUJTM

=EXPAND '../include/OUTHBK.inc'
      CHARACTER*44  TEMPNM
C
C========< Entry Point >================================================
C
C--
C  Check if histogram name is defined.
C--
      DO 100 I = 1, 80
         IF ( HFILEN(I:I).NE.' ' ) THEN
            TEMPNM = HFILEN(I:)
          						GO TO 200
         ENDIF
100   CONTINUE
C--
C  Histogram file name not specified.
C--
      PRINT *,'Dis file not specified... Write on a temp. file.'
      TEMPNM = 'TEMPFILE.hbook'
C--
200   ILDIS = INDEX(TEMPNM,' ') - 1
C--
C  Output hists. and plots.
C--
      CALL HRPUT(0,TEMPNM(:ILDIS),'N')
C      CALL HPRINT(0)
C--
C  That's it.
C--
      RETURN
      END
