C*
C*
C*
C*
C*
C*
      PROGRAM    PLTCNT

      IMPLICIT   REAL*8 ( A-H, O-Z )
      PARAMETER ( NCT = 3, NA = 1 )
      REAL   *8  CONTUR(NCT), XYLIM(2,2), XY0(2), DXY0(2),  A(0:NA)
 
      REAL   *8  FNCT
      EXTERNAL   FNCT
      DATA LOU   / 20 /
C
C========< Entry Point >================================================
C
C--
C  Initialization.
C--
      EP   = 125.
C350      EP = 175.
      SG   = 0.17
      ENSG = 1.0
      XSKL = 0.98
      DXL  = 2.00
      CALL GTCHI2(0,EP,SG,ENSG,XSKL,DXL,AMP,AMD,NP,A,CHI2)
C--
C  Allocate output data set.
C--
C     CALL UALCPS(LOU,'TKSF.@.@TOP@.TDR','RENEW','FB',30,IRT)
C--
C  Initialize window parameters.
C--
C      XYLIM(1,1) =   80.
C      XYLIM(2,1) =  110.
C      XYLIM(1,2) =   20.
C      XYLIM(2,2) =   60.
      XYLIM(1,1) =   92.
      XYLIM(2,1) =  100.
      XYLIM(1,2) =   43.
      XYLIM(2,2) =   45.5
C--
C  Give a point within the innermost contour.
C     X0 = AMP
C     Y0 = AMD
C--
C     CHI2MN  = 16.5
C     XY0(1)  = 214.1
C     XY0(2)  = 166.0
C250      CHI2MN  = 22.0
C250      XY0(1)  =  98.8
C250      XY0(2)  =  41.6
C350      CHI2MN  =  27.6
C350      XY0(1)  =  93.5
C350      XY0(2)  =  41.5
      XY0(1)  =  96.97
      XY0(2)  =  44.18
      CHI2MN  =  23.97
      DXY0(1) =   1.
      DXY0(2) =   1.
      CALL GTCHI2(1,EP,SG,ENSG,XSKL,DXL,XY0(1),XY0(2),NP,A,CHI2)
      PRINT *, ' XY0(1), XY0(2), CHI2 = ', XY0(1), XY0(2), CHI2
C--
C  Initialize countour parameters.
C--
      CHI1S  = CHI2MN + 1.00
      CHI68  = CHI2MN + 4.00
      CHI90  = CHI2MN + 4.61
C      CHI68  = CHI2MN + 2.28
C      CHI90  = CHI2MN + 4.61
C--
      CONTUR(1)  = CHI1S
      CONTUR(2)  = CHI68
      CONTUR(3)  = CHI90
C--
C  Draw contours.
C--
      DO 100 ICT = 1, 2
         CALL UCONTR(FNCT,1,CONTUR(ICT),XYLIM,XY0,DXY0,LOU)
C>>>
C           WRITE(LOU,*) XY0(1), XY0(2)
C           WRITE(LOU,'('' SYMBOL 9O SIZE 0.5; PLOT'')')
C           WRITE(LOU,'('' SYMBOL 9O SIZE 0.1'')')
C>>>
100   CONTINUE
C--
C  That's it.
C--
      STOP
      END
