CINCLUDE AMPSSE
CINCLUDE TTASSE
CINCLUDE SGSSEH
CINCLUDE AMPSSM
CINCLUDE TTASSM
CINCLUDE SGSSM
CINCLUDE COUPLSUB
CINCLUDE SFMASS
CINCLUDE INOMIX
CINCLUDE SWPELM
CINCLUDE INIPRM
 
      IMPLICIT   REAL*8  ( A-H, O-Z )
      REAL   *8  AM(2), AMX(4), CGE(2), CZE(2), CGSE(2), CZSE(2)
      COMPLEX*16 CX(2,2,4)
      PARAMETER  ( NP = 1000 )
      REAL   *8  XDATA(NP), YDATA(NP,4)
C
C==================< Entry Point >======================================
C
C--
C  Set experimental parameters.
C--
      RS   = 500
      POLE = 0
C--
C  Set MSSM parameters.
C--
      IFLG  = 1
      AM0   = 150.D0
      AMU   = 400.D0
      AM2   = 200.D0
      TNB   = 2.D0
C--
C     AM0   = 100.D0
C     AMU   = 100.D0
C     AM2   = 40.D0
C     TNB   = 2.D0
C--
      x2PI  = 2*ACOS(-1.D0)
C--
      CALL INIPRM(4,IFLG,AM0,AMU,AM2,TNB,
     .            AMZ,AM,AMX,CX,CGE,CZE,CGSE,CZSE)
C--
      WRITE(20,'(''( AM0  = '',F8.2)') AM0
      WRITE(20,'(''( AMU  = '',F8.2)') AMU
      WRITE(20,'(''( AM2  = '',F8.2)') AM2
      WRITE(20,'(''( TNB  = '',F8.2)') TNB
      WRITE(20,'(''( AMEL = '',F8.2)') AM(1)
      WRITE(20,'(''( AMER = '',F8.2)') AM(2)
      WRITE(20,'(''( AMX1 = '',F8.2)') AMX(1)
      WRITE(20,'(''( AMX2 = '',F8.2)') AMX(2)
      WRITE(20,'(''( AMX3 = '',F8.2)') AMX(3)
      WRITE(20,'(''( AMX4 = '',F8.2)') AMX(4)
C--
C  Loop over final state chirality combinations.
C--
      AMEL = AM(1)
      AMER = AM(2)
      DO 1000 MODE = 1, 4
C--
C  Set selectron masses.
C--
         IF ( MODE.EQ.1 ) THEN
            AM(1) = AMEL
            AM(2) = AMEL
         ELSE IF ( MODE.EQ.2 ) THEN
            AM(1) = AMER
            AM(2) = AMER
         ELSE IF ( MODE.EQ.3 ) THEN
            AM(1) = AMER
            AM(2) = AMEL
         ELSE IF ( MODE.EQ.4 ) THEN
            AM(1) = AMEL
            AM(2) = AMER
         ENDIF
C--
C  Loop over cos(theta).
C--
         NCS  = 200
         CSMN = -0.99
         CSMX = -CSMN
         DCS  = (CSMX-CSMN)/NCS
C--
         DO 100 ICS = 0, NCS
            CSTH = CSMN + ICS*DCS
            CALL DSSESE(MODE,AMZ,AM,AMX,CX,CGE,CZE,CGSE,CZSE,
     .                  RS,POLE,CSTH, SG)
C           CALL DSSMSM(MODE,AMZ,AM,CGE,CZE,CGSE,CZSE,
C    .                  RS,POLE,CSTH, SG)
            XDATA(     ICS) = CSTH
            YDATA(ICS,MODE) = SG*x2PI
100      CONTINUE
1000  CONTINUE
C--
C  Prepare topdraw data.
C--
      WRITE(20,'(''SET LIMITS X -1 1 Y 0. 2       '')')
      WRITE(20,'(''(SET LIMITS X -1 1 Y 1.E-2 1.E+3'')')
      WRITE(20,'(''(SET SCALE Y LOG'')')
      WRITE(20,'(''SET ORDER X Y DUMMY DUMMY DUMMY'')')
      DO 200 ICS = 0, NCS
         WRITE(20,'(5E12.3)') XDATA(ICS), (YDATA(ICS,I),I=1,4)
200   CONTINUE
      WRITE(20,'(''JOIN'')')
C--
C  That's it.
C--
      STOP
      END
 
C*
C*    AMZ       :(R*8 ): Z  mass
C*    AM (   1) :(R*8 ): sm- mass
C*       (   2) :(R*8 ): sm+ mass
C*    CGE(   1) :(R*8 ): e-gamma-e(L) coupling
C*       (   2) :(R*8 ): e-gamma-e(R) coupling
C*    CZE(   1) :(R*8 ): e-Z-e(L) coupling
C*       (   2) :(R*8 ): e-Z-e(R) coupling
C*    CGSE(  1) :(R*8 ): se-gamma-se(L) coupling
C*        (  2) :(R*8 ): se-gamma-se(R) coupling
C*    CZSE(  1) :(R*8 ): se-Z-se(L) coupling
C*        (  2) :(R*8 ): se-Z-se(R) coupling
C*    CSTH      :(R*8 ): cos(theta)
C*
 
      SUBROUTINE DSSMSM(MODE,AMZ,AM,CGE,CZE,CGSE,CZSE,
     .                  RS,POLE,CSTH,SG)
 
      IMPLICIT   REAL*4  ( A-H, O-Z )
      INTEGER*4  MODE
      REAL   *8  RS, POLE, AMZ, AM(2),
     .           CGE(2), CZE(2), CGSE(2), CZSE(2), CSTH, SG
C--
      REAL   *4  GAL(2), GAX, GZL(2), GZX,
     .           AMSZ, GAMZ, AMSE(2)
C--
      INTEGER*4  IDSE(2,4)
      DATA IDSE  /  1, 1,   2, 2,   2, 1,   1, 2 /
C--
C  Statement function.
C--
      BETA(X1,X2) = SQRT( 1 - 2*(X1+X2) + (X1-X2)**2 )
C
C========< Entry Point >================================================
C
C--
C  Branch on the final state chirality combinations.
C     MODE = 1 : LL (SE+,SE-)
C          = 2 : RR
C          = 3 : LR
C          = 4 : RL
C--
      IE  = IDSE(1,MODE)
      IP  = IDSE(2,MODE)
C--
      AMSZ   = AMZ
      GAMZ   = 0
      AMSE(1) = AM(1)
      AMSE(2) = AM(2)
C--
C  LL/RR cases.
C--
      IF ( MODE.LE.2 ) THEN
         GAL(1) = CGE(1)
         GAL(2) = CGE(2)
         GZL(1) = CZE(1)
         GZL(2) = CZE(2)
         GAX    = CGSE(1)
         GZX    = CZSE(IE)
C--
C  Calculate differential coss section.
C--
         PL  = POLE
         CS4 = CSTH
         RS4 = RS
         CALL SGSSM(GAL,GAX,GZL,GZX,AMSZ,GAMZ,
     .              AMSE, PL, RS4, CS4, 0., SG4)
         SG  = SG4
C--
C  LR/RL cases.
C--
      ELSE
         SG = 0
      ENDIF
C--
C  That's it.
C--
      RETURN
      END
C*
C*    AMZ       :(R*8 ): Z  mass
C*    AM (   1) :(R*8 ): se- mass
C*       (   2) :(R*8 ): se+ mass
C*    AMX(   i) :(R*8 ): i-th neutralino mass
C*    CX(1,1,i) :(C*16): ino-e(L)-se(L) coupling
C*      (2,1,i) :(C*16): ino-e(R)-se(L) coupling
C*      (1,2,i) :(C*16): ino-e(L)-se(R) coupling
C*      (2,2,i) :(C*16): ino-e(R)-se(R) coupling
C*    CGE(   1) :(R*8 ): e-gamma-e(L) coupling
C*       (   2) :(R*8 ): e-gamma-e(R) coupling
C*    CZE(   1) :(R*8 ): e-Z-e(L) coupling
C*       (   2) :(R*8 ): e-Z-e(R) coupling
C*    CGSE(  1) :(R*8 ): se-gamma-se(L) coupling
C*        (  2) :(R*8 ): se-gamma-se(R) coupling
C*    CZSE(  1) :(R*8 ): se-Z-se(L) coupling
C*        (  2) :(R*8 ): se-Z-se(R) coupling
C*    CSTH      :(R*8 ): cos(theta)
C*
 
      SUBROUTINE DSSESE(MODE,AMZ,AM,AMX,CX,CGE,CZE,CGSE,CZSE,
     .                  RS,POLE,CSTH,SG)
 
      IMPLICIT   REAL*4  ( A-H, O-Z )
      INTEGER*4  MODE
      REAL   *8  RS, POLE, AMZ, AM(2), AMX(4),
     .           CGE(2), CZE(2), CGSE(2), CZSE(2), CSTH, SG
      COMPLEX*16 CX(2,2,4)
C--
      REAL   *4  GAL(2), GAX, GZL(2), GZX,
     .           AMN(4), GMN(4), AMSZ, GAMZ, AMSE(2)
      COMPLEX*8  GNESE(2,2,4)
C--
      INTEGER*4  IDSE(2,4)
      DATA IDSE  /  1, 1,   2, 2,   2, 1,   1, 2 /
C--
C  Statement function.
C--
      BETA(X1,X2) = SQRT( 1 - 2*(X1+X2) + (X1-X2)**2 )
C
C========< Entry Point >================================================
C
C--
C  Branch on the final state chirality combinations.
C     MODE = 1 : LL (SE+,SE-)
C          = 2 : RR
C          = 3 : LR
C          = 4 : RL
C--
      IE  = IDSE(1,MODE)
      IP  = IDSE(2,MODE)
C--
      AMN(1) = AMX(1)
      AMN(2) = AMX(2)
      AMN(3) = AMX(3)
      AMN(4) = AMX(4)
      GMN(1) = 0
      GMN(2) = 0
      GMN(3) = 0
      GMN(4) = 0
      AMSZ   = AMZ
      GAMZ   = 0
      AMSE(1) = AM(1)
      AMSE(2) = AM(2)
      DO 5 K = 1, 4
         GNESE(1,1,K) = CX(1,IE,K)
         GNESE(2,1,K) = CX(2,IE,K)
C>>>
C>>> Be careful for the ordering of left/right in the following
C>>> two lines.
         GNESE(2,2,K) = CONJG(CX(1,IP,K))
         GNESE(1,2,K) = CONJG(CX(2,IP,K))
C>>>
5     CONTINUE
C--
C  LL/RR cases.
C--
      IF ( MODE.LE.2 ) THEN
         GAL(1) = CGE(1)
         GAL(2) = CGE(2)
         GZL(1) = CZE(1)
         GZL(2) = CZE(2)
         GAX    = CGSE(1)
         GZX    = CZSE(IE)
C--
C  LR/RL cases.
C--
      ELSE
         GAL(1) = 0
         GAL(2) = 0
         GZL(1) = 0
         GZL(2) = 0
         GAX    = 0
         GZX    = 0
      ENDIF
C--
C  Calculate differential coss section.
C--
      PL  = POLE
      CS4 = CSTH
      RS4 = RS
      CALL SGSSE(GAL,GAX,GZL,GZX,GNESE,AMN,GMN,AMSZ,GAMZ,
     .           AMSE, PL, RS4, CS4, 0., SG4)
      SG  = SG4
C--
C  That's it.
C--
      RETURN
      END
