C   ========================
C     Cuts for 6J Selection
C   ========================
C
C--
C  Parameters for jet-clustering.
C--
      REAL*4          YCUT(0:MXxYCT)
      DATA   YCUT     / 4.0E-3,
     .                  0.5E-3, 1.0E-3, 1.5E-3, 2.0E-3, 2.5E-3,
     .                  3.0E-3, 3.5E-3, 4.0E-3, 4.5E-3, 5.0E-3,
     .                  5.5E-3, 6.0E-3, 6.5E-3, 7.0E-3, 7.5E-3,
     .                  8.0E-3, 8.5E-3, 9.0E-3, 9.5E-3, 1.0E-2 /
C--
      DATA NOMYCT     /  10  /
      DATA DYMAX      / 1.E-2/
      DATA NTRYMX     /  50  /
C--
C  Track selection.
C--
      DATA NTRKCT     /  20  /
      DATA ECUT       /  0.1 /
C--
C  Lepton cuts.
C--
C13   DATA ELPLCT     /   2. /
C1-12,14-18
      DATA ELPLCT     / 999. /
C--
C  Energy momentum balance.
C--
C1-11 DATA PTCUT      /  70. /
C12   DATA PTCUT      /  20. /
C13   DATA PTCUT      /  12. /
C14   DATA PTCUT      /  10. /
C15   DATA PTCUT      /  40. /
C16-18 DATA PTCUT      /  50. /
C19
      DATA PTCUT      /  12. /
C--
C1-11 DATA PLCUT      / 999. /
C12   DATA PLCUT      /  25. /
C13   DATA PLCUT      /  15. /
C14   DATA PLCUT      /  10. /
C15   DATA PLCUT      /  40. /
C16-18 DATA PLCUT      /  50. /
C19
      DATA PLCUT      /  12. /
C--
C1-15 DATA DEVSCT     /  50. /
C16-18 DATA DEVSCT     / 100. /
C19
      DATA DEVSCT     /  20. /
      DATA EVOFF      / 10.0 /
C--
C  Mass cuts.
C--
C1-11 DATA AMJCUT     / 15.0 /
C13   DATA AMJCUT     / 999. /
C12,14,15 DATA AMJCUT     /  25. /
C16-18 DATA AMJCUT     /  60. /
C19
      DATA AMJCUT     /  12. /
C--
C1-19 DATA RMTCUT     / 50.0 /
C19
      DATA RMTCUT     / 25.0 /
C--
C  Angle cuts.
C--
C1-8  DATA CSJCUT     / 999. /
C9,13,14 DATA CSJCUT     / 0.90 /
C10-12,15 DATA CSJCUT     / 0.95 /
C16,18 DATA CSJCUT     / 999. /
C19
      DATA CSJCUT     / 0.90 /
C--
C1-12 DATA PTMCUT     / 999. /
C13,14,16-19
      DATA PTMCUT     /   2. /
C--
C1-13 DATA CSMJCT     / 999. /
CX    DATA CSMJCT     / 0.98 /
C14,15,16-19
      DATA CSMJCT     / 999. /
C--
C13,14 DATA CSJJCT     / 0.85 /
C1-12,15-18 DATA CSJJCT     / 999. /
C19
      DATA CSJJCT     / 999. /
C--
C1-18 DATA CSBBCT     / 999. /
C19
      DATA CSBBCT     / 999. /
C--
C1-8  DATA CSBWCT     /  99. /
C9,13,14 DATA CSBWCT     /-0.75 /
C10-12,15-19
      DATA CSBWCT     /-0.65 /
C--
C13,14 DATA RCBWCT     / 0.25 /
C1-12,15-18 DATA RCBWCT     / 999. /
C19
      DATA RCBWCT     / 0.25 /
C--
C  B-tagging.
C--
C1-9  DATA DCBCT      / -99. /
C13,14 DATA DCBCT      / 0.98 /
C10-12,15,16 DATA DCBCT      / 0.95 /
C17   DATA DCBCT      / 0.80 /
C18--> Use BTAGGN instead.
C18   DATA NBTKCT     /    1 /
C19
      DATA NBTKCT     /    2 /
C19
      DATA NBJLCT     /    2 /
      DATA NBJHCT     /  999 /
C--
C  Parameters for best candidate selection.
C--
      DATA AMW        / 80.0 /
      DATA AMZ        / 91.1 /
      DATA AMT        / 150. /
      DATA SGMV       /   4. /
C--
C1-8  DATA SGMT       /  30. /
C9-19
      DATA SGMT       /   5. /
C--
C  Event shape cut.
C--
C1-14 DATA THRSCT     / 0.75 /
C15-19
      DATA THRSCT     / 1.00 /
C--
C  Cut on #ttbar candidates.
C--
C1-19
      DATA NTTCUT     /  999 /
C--
C  Artificial cut knowing generator information.
C--
CX    DATA ICMBCT     /    1 /
C1-19
      DATA ICMBCT     /    0 /
