C
C ===========================
C    Cuts for 6J Selection
C ===========================
C
C        CUT23: Current best cuts for momentum measurement.
C--
C  Parameters for jet-clustering.
C--
      REAL*4          YCUT(0:MXxYCT)
      DATA   YCUT     / 4.0E-3,
     .                  0.5E-3, 1.0E-3, 1.5E-3, 2.0E-3, 2.5E-3,
     .                  3.0E-3, 3.5E-3, 4.0E-3, 4.5E-3, 5.0E-3,
     .                  5.5E-3, 6.0E-3, 6.5E-3, 7.0E-3, 7.5E-3,
     .                  8.0E-3, 8.5E-3, 9.0E-3, 9.5E-3, 1.0E-2 /
C--
      DATA NOMYCT     /  10  /
      DATA DYMAX      / 1.E-2/
      DATA NTRYMX     /  50  /
C--
C  Track selection.
C--
      DATA NTRKCT     /  20  /
      DATA ECUT       /  0.1 /
C--
C  Lepton cuts.
C--
      DATA ELPLCT     / 999. /
C--
C  Energy momentum balance.
C--
      DATA PTCUT      /  12. /
      DATA PLCUT      /  12. /
      DATA DEVSCT     /  20. /
C--
      DATA EVOFF      /  10. /
C--
C  Mass cuts.
C--
      DATA AMJCUT     /  15. /
      DATA RMTCUT     /  15. /
C--
C  Angle cuts.
C--
      DATA CSJCUT     / 0.90 /
C--
      DATA PTMCUT     /   2. /
      DATA CSMJCT     / 999. /
C--
      DATA CSJJCT     / 0.85 /
C--
      DATA CSBBCT     / 0.65 /
C--
      DATA CSBWCT     /-0.75 /
      DATA RCBWCT     / 0.25 /
C--
C  B-tagging.
C--
      DATA NBTKCT     /    2 /
      DATA NBJLCT     /    2 /
      DATA NBJHCT     /    2 /
C--
C  Parameters for best candidate selection.
C--
      DATA AMW        / 80.0 /
      DATA AMT        / 150. /
C--
      DATA SGMV       /   4. /
      DATA SGMT       /   5. /
C--
C  Event shape cut.
C--
      DATA THRSCT     / 1.00 /
C--
C  Cut on #ttbar candidates.
C--
      DATA NTTCUT     /  999 /
C--
C  Artificial cut knowing generator information.
C--
      DATA ICMBCT     /    0 /
