      IMPLICIT    REAL*8   ( A-H, O-Z )
      PARAMETER ( MXxPT = 500 )
      REAL*4      XDAT(0:MXxPT), YDAT(0:MXxPT)
      DATA LIU    /10/
      DATA LOU    /20/
C--
C  Set beam energy spread.
C--
      SGEB = 0.005D0
C--
C  Read in sqrt(s) distribution.
C--
      NP = -1
1     READ(LIU,*,END=10) X, Y, DY
      NP  = NP + 1
      RSH = 1 + 5*SGEB - EXP(-X)
      XDAT(NP) = RSH
      YDAT(NP) = Y
      GO TO 1
C--
C  End of data.
C--
10    PRINT *, ' NP  = ', NP
C--
C  Integrate the spectrum.
C--
      SUM = AREA (XDAT,YDAT,NP+1,3)
      PRINT *, 'SUM = ', SUM
C--
C  Draw effective RS spectrum.
C--
      WRITE(LOU,*) 'SET ORDER X Y'
      DO 20 IP = 0, NP
         WRITE(LOU,*) XDAT(IP), YDAT(IP)/SUM
20    CONTINUE
      WRITE(LOU,*) 'HIST'
C--
C  That's it.
C--
      STOP
      END
