C*   95/03/29  K.Fujii		Replaced /TTZCNF/ by /FFHCNF/ to
C*				store fermion type information.
C*
      SUBROUTINE USERIN
 
      IMPLICIT REAL*8 (A-H,O-Z)
C--
      PARAMETER (MXDIM = 50 )
      COMMON /BPARM1/ XL(MXDIM),XU(MXDIM),NDIM,NWILD,IG(MXDIM),NCALL
      COMMON /BPARM2/ ACC1,ACC2,ITMX1,ITMX2
C--
      INCLUDE 'FFHCNF.inc'
      INCLUDE 'USRPRM.inc'
=EXPAND 'gen_lib/ss/USSPRM.inc'
=EXPAND 'gen_lib/sm/USMPRM.inc'
=EXPAND 'gen_lib/sm/BEMCNS.inc'
=EXPAND 'BASESV51/BSITPR.inc'
=EXPAND 'BASESV51/BSHUFL.inc'
C--
C  Local R*4 variables used in subroutine calls.
C--
      REAL*4        ALF
C
C========< Entry Point >================================================
C
C--
C  Check if inputs from FT05 are consistent with those used in the
C  integration step, when NGETBS = 1. Otherwise, Write the inputs 
C  to 'BASES:Inputs'.
C--
      CALL SPPARM
C--
C  Initialize numerical constants and particle table.
C--
      ALF   = 1/ALFI
      CALL INSMCN(ALF,ALFS,AMSW,AMSZ,AMSH,AMST)
      CALL INSSCN(ALF,ALFS,AMSW,AMSZ,AM0,AMU,AM2,TANB,AMA)
      CALL INHGCN
C--
C  Set user constants.
C--
      ROOTS  = SQRTS
      SGEBM  = SGMEBM
      POLE   = POLEBM
C--
      IHGTYP      = IHTP
      IF ( IHTP.EQ.4 ) THEN
         IGTLQF(1,1) = IGFR
         IGTLQF(2,1) = 2
         IGTLQF(3,1) = LQFR
         IGTLQF(1,2) = IGFR
         IGTLQF(2,2) = 1
         IGTLQF(3,2) = LQFR
      ELSE
         IGTLQF(1,1) = IGFR
         IGTLQF(2,1) = ITFR
         IGTLQF(3,1) = LQFR
         IGTLQF(1,2) = IGFR
         IGTLQF(2,2) = ITFR
         IGTLQF(3,2) = LQFR
      ENDIF
C--      
      PRINT *, ' ******< Job constants >*********** '
      PRINT *, '  '
      PRINT *, '     ROOTS  = ', ROOTS
      PRINT *, '     SGEBM  = ', SGEBM
      PRINT *, '     POLE   = ', POLE
      PRINT *, '     IHGTYP = ', IHGTYP
      PRINT *, '     IGTLQF = ', IGTLQF
      PRINT *, '  '
      PRINT *, ' ********************************** '
C--
C  Set BASES constants.
C--
      NDIM   = 6
      NWILD  = 2
C--
      NCALL  = NCAL
      ITMX1  = ITM1
      ITMX2  = ITM2    
C--
C  Set lower and upper limits.
C--
      DO 100 IX = 1, NDIM
         XL(IX) = 0
         XU(IX) = 1
100   CONTINUE
C--
C  Define hists. and plots.
C--
      Q2MN = 0
      Q2MX = ROOTS
      CALL XHINIT( 1, -1.0D0, 1.0D0, 50,'cos(theta_H)     ')
      CALL XHINIT( 2,  0.0D0,360.D0, 50,'phi_H            ')
      CALL XHINIT( 3, -1.0D0, 1.0D0, 50,'cos(theta_f_bar) ')
      CALL XHINIT( 4,  0.0D0,360.D0, 50,'phi_f_bar        ')
      CALL XHINIT( 5,   Q2MN,  Q2MX, 50,'M_f-bar-f        ')
      CALL XHINIT( 6,  0.0D0, 18.D0, 18,'hel. comb.       ')
C--
C  That's it.
C--
      RETURN
      END
