CINCLUDE HIOKI
CINCLUDE UCONTR
      IMPLICIT REAL*8 (A-H,O-Z)
C--
      COMMON /AMCENT/ AMW0, AMZ0, AMT0, AMH0, DAMW, DAMZ, DAMT, DAMH
      REAL   *8       AMW0, AMZ0, AMT0, AMH0, DAMW, DAMZ, DAMT, DAMH
      COMMON /MEASTP/ ITYP
      INTEGER*4       ITYP
C--
      REAL   *8       WMASS(5)
C--
      PARAMETER       ( NCT = 1 )
      REAL   *8       CONTUR(NCT), XYLIM(2,2), XY0(2), DXY0(2)
      REAL   *8       FNCT
      EXTERNAL        FNCT
C
C========< Entry Point >================================================
C
C--
C  Select measurement type.
C     ITYP    = 1 : M_W and M_Z
C             = 2 : M_W, M_Z, and m_t
C--
      ITYP    = 2
C--
C  Initialize particle masses.
C--
      CALL INIMAS
      AMZ0    =  91.19D0
C     AMT0    = 150.D0
      AMT0    = 170.D0
      AMH0    = 500.D0
      CALL ZHWMAS( DR, WMASS, AMZ0, AMT0, AMH0 )
      AMW0    = WMASS(4)
C--
C  Measurement errors.
C--
      DAMW    =  SQRT( (12.D-3)**2 + (17.D-3)**2 )
      DAMZ    =   2.D-3
      IF ( ITYP.EQ.1 ) THEN
         DAMT    = 20.0D0
      ELSE
C         DAMT    =  0.5D0
C         DAMT    =  5.0D0
         DAMT    = 10.0D0
      ENDIF
      DAMH    =  20.D0
C--
C  Set center values.
C--
      XY0(1)  = AMT0
      XY0(2)  = AMH0
      DXY0(1) = DAMT
      DXY0(2) = DAMH
C--
C  Initialize window parameters.
C--
      XYLIM(1,1) =  AMT0 - 2*DAMT
      XYLIM(2,1) =  AMT0 + 2*DAMT
      XYLIM(1,2) =    1.
      XYLIM(2,2) = 1500.
C--
C  Initialize countour parameters.
C--
      CONTUR(1) = 1
C--
C  Draw contours.
C--
      LOU = 20
      DO 10 ICT = 1, NCT
         CALL UCONTR(FNCT,NCT,CONTUR(ICT),XYLIM,XY0,DXY0,LOU)
10    CONTINUE
      PRINT *, '(END)'
C--
C  That's it.
C--
      STOP
      END
 
      DOUBLE PRECISION FUNCTION FNCT(AMT,AMH)
 
      IMPLICIT   REAL*8 ( A-H, O-Z )
      REAL   *8  AMT, AMH
C--
      COMMON /AMCENT/ AMW0, AMZ0, AMT0, AMH0, DAMW, DAMZ, DAMT, DAMH
      REAL   *8       AMW0, AMZ0, AMT0, AMH0, DAMW, DAMZ, DAMT, DAMH
      COMMON /MEASTP/ ITYP
      INTEGER*4       ITYP
C--
      REAL   *8  WMASS(5)
C
C========< Entry Point >================================================
C
C--
C  Evaluate function value.
C--
      CALL ZHWMAS( DR, WMASS, AMZ0, AMT, AMH )
      AMW  = WMASS(4)
      IF ( ITYP.EQ.1 ) THEN
         FNCT = ((AMW0-AMW)/DAMW)**2
      ELSE
         FNCT = ((AMW0-AMW)/DAMW)**2 + ((AMT0-AMT)/DAMT)**2
      ENDIF
C--
C  That's it.
C--
      RETURN
      END
