


      SUBROUTINE PISC(NTRK,LNxPV,MXxPV,QV,IPTOJ,
     .                           NJ,IJI,NPINJ,NCTKJ,ICHGJ,ISC)
      DIMENSION       QV(LNxPV,MXxPV),IPTOJ(MXxPV),
     .                ICHGJ(NJ),NCTKJ(NJ),NPINJ(NJ),IJI(NJ),
     .                ISC(NJ)
C 
C
C  NTRK  :  NUMBER OF JET
C  IPTOJ(NTRK) :  NUMBER OF JET THAT A TRACK BELONG
C  NJ        :  NUMBER OF JET
c  IJI(NJ)   :  NUMBER OF ELEMENT OF QV WHERE JET INFO CONTAINED
C  NCTKJ(NJ) :  NUMBER OF CHARGED TRACK IN A JET
C  NPINJ(NJ) :  NUMBER OF PARTICLE IN A JET, NOT THE SAME
C               ARRAY OF THE MAIN ROUTINE, HAVE TO BE 
C               REDEFINED BEFORE CALLING.
C  ICHGJ(NJ) :  NUMBER OF CHARGED TRACK IN A JET
C  QV(L,1-NTRK)           : TRACK INFO
C  QV(L,IJI(1)-IJI(NJ)) ) : JET INFO 
C  ISC(NJ)   : IDENTIFICATION CODE, Should be set equal to be zero
C                                   before call of 
C                                   the subroutine set.
C      1: a1 3-prong
C      2: a1 1-prong
C      4: rho
C      8: pi
C      if a jet is identified both a1 1 prong and rho, for example, 
C      you get 6 as the return code after calling the selection 
C      subroutines. Probablly, cuts should be chosen so that 1,2,4,8 
C      is maximized, 
C      while other numbers are minimized. 
C--
C  Look at 1-charged track and 0 neutral track system, if any.
C--
      DATA AMJCUT     / 2.0  /
C
      DO 600 IJ = 1, NJ
         NNUT = NPINJ(IJ) -  NCTKJ(IJ)               
	 EJET = QV(4,IJI(IJ))
	    CALL HCUM2(228,EJET,NNUT+.1,1.)
         IF ( NCTKJ(IJ).EQ.1.AND.NNUT.EQ.0) THEN
            ITYP =QV(10,1)
            IF(ITYP.NE.5) GOTO 600 
            CALL HCUM1(30,EJET,1.)
            ISC(IJ)=ISC(IJ)+8
         ENDIF
600   CONTINUE
      RETURN
      END
