C*
C* MER-MEM contours.
C*
C*
      AMER = 141.89
      AMMR = 141.89
C--
      DC01 = 1.00
      DC68 = 2.28
      DC90 = 4.61
      FAC  = SQRT(DC01)
C     FAC  = SQRT(DC90)
      DAME = 0.9*FAC
      DAMM = 1.4*FAC
C--
      NP   = 20
      PI   = ACOS(-1.)
      DTH  = 2*PI/NP
      PHI  = 0.
C--
      CS   = COS(PHI)
      SN   = SIN(PHI)
C--
      WRITE(20,*) 'SET FONT DUPLEX'
      WRITE(20,*) 'NEW FRAME'
      WRITE(20,*) 'SET LIMITS X 0 200 Y 0 200'
      WRITE(20,*) 'SET ORDER X Y'
      DO 10 I = 0, NP
         TH = I*DTH
         XX = DAME*COS(TH)
         YY = DAMM*SIN(TH)
         X =  CS*XX - SN*YY + AMER
         Y =  SN*XX + CS*YY + AMMR
         WRITE(20,*) X, Y
10    CONTINUE
      WRITE(20,*) 'JOIN'
C--
      STOP
      END
C*
C* M1-M2 contours.
C*
C*
      S2W  = 0.23
      AMER = 141.89
      AMU  = 400
      AM2  = 250
      TNB  = +2
      AM1  = AM2*S2W/(1.-S2W)*(5./3.)
C--
      DC01 = 1.
      DC68 = 2.28
      DC90 = 4.61
C     FAC  = SQRT(DC90)
      FAC  = SQRT(DC01)
      DAM2 = 4.0*FAC
      DAM1 = 1.0*FAC
C--
      NP   = 20
      PI   = ACOS(-1.)
      DTH  = 2*PI/NP
      PHI  = 0.2
C--
      CS   = COS(PHI)
      SN   = SIN(PHI)
C--
      WRITE(20,*) 'SET FONT DUPLEX'
      WRITE(20,*) 'NEW FRAME'
      WRITE(20,*) 'SET LIMITS X 0 400 Y 0 200'
      WRITE(20,*) 'SET ORDER X Y'
      DO 10 I = 0, NP
         TH = I*DTH
         XX = DAM2*COS(TH)
         YY = DAM1*SIN(TH)
         X =  CS*XX - SN*YY + AM2
         Y =  SN*XX + CS*YY + AM1
         WRITE(20,*) X, Y
10    CONTINUE
      WRITE(20,*) 'JOIN'
C--
      STOP
      END
C*
C* DEL(MSL**2)-M2 contours.
C*
C*
      DC01 = 1.00
      DC68 = 2.28
      DC90 = 4.61
C     FAC  = SQRT(DC90)
      FAC  = SQRT(DC01)
C--
      AMER  = 141.89
      DAMER =   0.9
      AMEL  = 235.52
      DAMEL =   3.3
      AM2   = 250.
      DAM2  = 4.
      AM22  = AM2**2
      DAM22 = 2*AM2*DAM2*FAC
      DAM   = AMEL**2 - AMER**2
      DDAM  = 2*SQRT( (AMEL*DAMEL)**2 + (AMER*DAMER)**2 )*FAC
      PRINT *, ' DDAM = ', DDAM
C--
      NP   = 20
      PI   = ACOS(-1.)
      DTH  = 2*PI/NP
      PHI  = 0.
C--
      CS   = COS(PHI)
      SN   = SIN(PHI)
C--
      WRITE(20,*) 'SET FONT DUPLEX'
      WRITE(20,*) 'NEW FRAME'
      WRITE(20,*) 'SET LIMITS X 0 40000 Y 0 160000'
      WRITE(20,*) 'SET ORDER X Y'
      DO 10 I = 0, NP
         TH = I*DTH
         XX = DDAM*COS(TH)
         YY = DAM22*SIN(TH)
         X =  CS*XX - SN*YY + DAM
         Y =  SN*XX + CS*YY + AM22
         WRITE(20,*) X, Y
10    CONTINUE
      WRITE(20,*) 'JOIN'
C--
      STOP
      END
