C*
C*  This routine draws the best fit curve.
C*
      PROGRAM PLTBST

      IMPLICIT REAL*8 ( A-H, O-Z )
      REAL*8   A(0:1)
      DATA LOU /20/
C
C==================< Entry Point >======================================
C
C--
C  Initialization.
C--
      EP = 125.
C350      EP = 175.
      CALL GTCHI2(0,EP,AMP,AMD,NP,A,CHI2)
C--
C  Calculate chi**2.
C--
      AMP = 96.7
      AMD = 44.4
C250      AMP = 98.8
C250      AMD = 41.6
C350      AMP = 93.5
C350      AMD = 41.5
C--
      CALL GTCHI2(1,EP,AMP,AMD,NP,A,CHI2)
      FUNC = CHI2
      PRINT *, ' NP = ', NP, ' CHI2 = ', CHI2
      PRINT *, ' A  = ', A
C--
C  Prepare topdraw data.
C--
      CALL ELBXTR(EP,AMP,AMD,EMIN,EMAX)
      NE = 50
      DE = ( EMAX - EMIN )/NE
      WRITE(LOU,*) 'SET ORDER X Y'
      DO 30 IE = 0, NE
         E = EMIN + IE*DE
         F = (E-EMIN)*(EMAX-E)*(A(0)+A(1)*E)
         WRITE(LOU,*) E, F
30    CONTINUE
      WRITE(LOU,*) 'JOIN'
C--
C  That's it.
C--
      STOP
      END
