      SUBROUTINE TTASSM(GAL,GAX,GZL,GZX,AMZ,GMZ,
     .                  IHEL, PV, AMP2)
 
      IMPLICIT   REAL*4  ( A-H, O-Z )
      REAL   *4  GAL(2), GAX, GZL(2), GZX, AMZ, GMZ
      INTEGER*4  IHEL(*)
      REAL   *4  PV(0:3,*), AMP2
C--
      COMPLEX*8  EIN(6), EOT(6), XIN(3), XOT(3), AMP(0:2)
C
C========< Entry Point >================================================
C
C--
C  Prepare spinors for external lines.
C--
      AME = 0.511E-3
      CALL IXXXXX( PV(0,1),AME,IHEL(1),+1, EIN )
      CALL OXXXXX( PV(0,2),AME,IHEL(2),-1, EOT )
C--
C  Prepare scalar wave functions for external lines.
C--
      CALL SXXXXX( PV(0,4),+1,XIN )
      CALL SXXXXX( PV(0,3),+1,XOT )
C--
C  Calculate amplitude**2.
C--
      CALL AMPSSM (GAL,GAX,GZL,GZX,AMZ,GMZ,
     .             EIN,EOT,XIN,XOT,AMP)
      AMP2 = ABS(AMP(0))**2
C--
C  That's it.
C--
      RETURN
      END
