C   ========================
C     Cuts for LJ Selection
C   ========================
C
C--
C  Parameters for jet clustering.
C--
      REAL*4          YCUT(0:MXxYCT)
      DATA   YCUT     / 4.0E-3,
     .                  5.0E-3, 5.5E-3, 6.0E-3, 6.5E-3, 7.0E-3,
     .                  7.5E-3, 8.0E-3, 8.5E-3, 9.0E-3,10.0E-3,
     .                 11.0E-3,12.0E-3,13.0E-3,14.0E-3,15.0E-3,
     .                 16.0E-3,17.0E-3,18.0E-3,19.0E-3,40.0E-3/
C--
      DATA NOMYCT     /  1   /
      DATA DYMAX      / 1.E-2/
      DATA NTRYMX     /  50  /
C--
C  Track selection.
C--
      DATA NTRKCT     /  20  /
      DATA ECUT       /  0.1 /
C--
C  Lepton cuts.
C--
      DATA ELEPCT     / 20.  /
C9,13 DATA ELPLCT     /   2. /
C1-10,11,12,14-18
      DATA ELPLCT     / 999. /
C--
      DATA ECONTH     / 20.  /
      DATA ECNTCT     /  1.5 /
      DATA EOPLCT     / 0.70 /
      DATA EOPHCT     / 1.30 /
C--
C  Energy and momentum balance.
C--
      DATA PTCUT      / 999. /
      DATA PLCUT      / 999. /
      DATA DEVSCT     / 999. /
      DATA EVOFF      / 10.0 /
C--
C  Mass cuts.
C--
C15   DATA AMJCUT     / 50.0 /
C16   DATA AMJCUT     / 999. /
C1-14,17,18
      DATA AMJCUT     /  15. /
C--
      DATA RMTCUT     / 50.0 /
C1-9,13-16 DATA AMTJCT     / 999. /
C10-12,18
      DATA AMTJCT     / 15.0 /
C--
C  Angle cuts.
C--
C1-18
      DATA CSBWCT     /-0.75 /
C--
C1-17 DATA CSBBCT     / 1.00 /
C18
      DATA CSBBCT     / 0.70 /
C--
C7,16 DATA CSJCUT     / 0.95 /
C8,11 DATA CSJCUT     / 0.85 /
C9-10,12-15,17,18
      DATA CSJCUT     / 0.90 /
C--
C  B-tagging.
C--
C1-6  DATA DCBCT      / -99. /
C7-15 DATA DCBCT      / 0.99 /
C16   DATA DCBCT      / 0.80 /
C17--> Use BTAGGN instead.
      DATA NBTKCT     /    2 /
C17,18
      DATA NBJLCT     /    2 /
      DATA NBJHCT     /  999 /
C--
C  Event shape cut.
C--
      DATA THRSCT     / 1.00 /
C--
C  Parameters for best candidate selection.
C--
      DATA AMW        / 80.0 /
      DATA AMT        / 150. /
C--
C1-3  DATA SGMV       /   5. /
C4-18
      DATA SGMV       /   4. /
C--
C1-3  DATA SGMT       /  15. /
C1-11 DATA SGMT       /   8. /
C12-18
      DATA SGMT       /   5. /
