C
C ===========================
C    Cuts for LJ Selection
C ===========================
C
C        CUT18: Final cuts for momentum measurements.
C        CUT19: Additional cut on COSJJ.
C
C--
C  Parameters for jet clustering.
C--
      REAL*4          YCUT(0:MXxYCT)
      DATA   YCUT     / 4.0E-3,
     .                  5.0E-3, 5.5E-3, 6.0E-3, 6.5E-3, 7.0E-3,
     .                  7.5E-3, 8.0E-3, 8.5E-3, 9.0E-3,10.0E-3,
     .                 11.0E-3,12.0E-3,13.0E-3,14.0E-3,15.0E-3,
     .                 16.0E-3,17.0E-3,18.0E-3,19.0E-3,40.0E-3/
C--
      DATA NOMYCT     /  1   /
      DATA DYMAX      / 1.E-2/
      DATA NTRYMX     /  50  /
C--
C  Track selection.
C--
      DATA NTRKCT     /  20  /
      DATA ECUT       /  0.1 /
C--
C  Lepton cuts.
C--
      DATA ELEPCT     / 20.  /
      DATA ELPLCT     / 999. /
C--
      DATA ECONTH     / 20.  /
      DATA ECNTCT     /  1.5 /
      DATA EOPLCT     / 0.70 /
      DATA EOPHCT     / 1.30 /
C--
C  Energy and momentum balance.
C--
      DATA PTCUT      / 999. /
      DATA PLCUT      / 999. /
      DATA DEVSCT     / 999. /
      DATA EVOFF      / 10.0 /
C--
C  Mass cuts.
C--
      DATA AMJCUT     /  15. /
C--
      DATA RMTCUT     / 50.0 /
      DATA AMTJCT     / 15.0 /
C--
C  Angle cuts.
C--
      DATA CSJCUT     / 0.90 /
      DATA CSJJCT     / 999. /
C19   DATA CSJJCT     / 0.90 /
      DATA CSBWCT     /-0.75 /
      DATA CSBBCT     / 0.70 /
C--
C  B-tagging.
C--
      DATA NBTKCT     /    2 /
      DATA NBJLCT     /    2 /
      DATA NBJHCT     /  999 /
C--
C  Event shape cut.
C--
      DATA THRSCT     / 1.00 /
C--
C  Parameters for best candidate selection.
C--
      DATA AMW        / 80.0 /
      DATA AMT        / 150. /
C--
      DATA SGMV       /   4. /
C--
      DATA SGMT       /   5. /
C
C ===========================
C    Cuts for LJ Selection
C ===========================
C
C        CUT21,22: Test cuts for ds/dp.
C        CUT23   : Test cuts for ds/dp.
C        CUT24   : Final cuts for ds/dp.
C
C--
C  Parameters for jet clustering.
C--
      REAL*4          YCUT(0:MXxYCT)
      DATA   YCUT     / 4.0E-3,
     .                  5.0E-3, 5.5E-3, 6.0E-3, 6.5E-3, 7.0E-3,
     .                  7.5E-3, 8.0E-3, 8.5E-3, 9.0E-3,10.0E-3,
     .                 11.0E-3,12.0E-3,13.0E-3,14.0E-3,15.0E-3,
     .                 16.0E-3,17.0E-3,18.0E-3,19.0E-3,40.0E-3/
C--
      DATA NOMYCT     /  1   /
      DATA DYMAX      / 1.E-2/
      DATA NTRYMX     /  50  /
C--
C  Track selection.
C--
      DATA NTRKCT     /  20  /
      DATA ECUT       /  0.1 /
C--
C  Lepton cuts.
C--
      DATA ELEPCT     / 20.  /
      DATA ELPLCT     / 999. /
C--
      DATA ECONTH     / 20.  /
      DATA ECNTCT     /  1.5 /
      DATA EOPLCT     / 0.70 /
      DATA EOPHCT     / 1.30 /
C--
C  Energy and momentum balance.
C--
      DATA PTCUT      / 999. /
      DATA PLCUT      / 999. /
      DATA DEVSCT     / 999. /
      DATA EVOFF      / 10.0 /
C--
C  Mass cuts.
C--
C21,23DATA AMJCUT     /  60. /
C24
      DATA AMJCUT     /  20. /
C--
      DATA RMTCUT     / 50.0 /
C21,22DATA AMTJCT     / 999. /
C23,24
      DATA AMTJCT     /   8. /
C1-22 DATA DELAMT     /   0. /
C23,24
      DATA DELAMT     /  -4. /
C--
C  Angle cuts.
C--
C21,23DATA CSJCUT     / 0.90 /
C22,24
      DATA CSJCUT     / 0.95 /
      DATA CSJJCT     / 999. /
      DATA CSBWCT     /-0.75 /
      DATA CSBBCT     / 0.70 /
C--
C  B-tagging.
C--
      DATA NBTKCT     /    2 /
      DATA NBJLCT     /    2 /
      DATA NBJHCT     /  999 /
C--
C  Event shape cut.
C--
      DATA THRSCT     / 1.00 /
C--
C  Parameters for best candidate selection.
C--
      DATA AMW        / 80.0 /
      DATA AMT        / 150. /
C--
      DATA SGMV       /   4. /
C--
      DATA SGMT       /   5. /
