C* (Update Record)
C*    95/06/24  K.Fujii          Original version.
 
      SUBROUTINE TTATT(IHEL,PV,AMP2)
 
      IMPLICIT   REAL*4  ( A-H, O-Z )
#include "SMCONS.inc"
#include "SMPTAB.inc"
      INTEGER*4  IHEL(*)
      REAL   *4  PV(0:3,4), AMP2(0:2)
C--
      COMPLEX*8  EIN(6), EOT(6), TIN(6), TOT(6), AMP(0:2)
      REAL   *4  GAL(2), GAU(2), GAD(2), GWF(2), GZN(2), GZL(2), GZU(2),
     .           GZD(2), G1(2), GW, GWWZ, GWWA
      DATA NCALL / 0 /
C
C========< Entry Point >================================================
C
C--
C  Prepare coupling constants.
C--
      IF ( NCALL.EQ.0 ) THEN
         NCALL  = 1
         ALF    = xALF
         SN2W   = xSIN2W
         CS2W   = xCOS2W
         AMSE   = AMF(1,2,1)
         AMST   = AMF(3,1,2)
         AMSZ   = AMZ
         GAMZ   = GMZTOT
         CALL UHCUPL(ALF,SN2W, GAL,GAU,GAD,GWF,GZN,GZL,GZU,GZD,G1,
     .               GW,GWWZ,GWWA)
         COLOR      = 3*(1+xALFS/xPI)
      ENDIF
C--
C  Prepare spinors for external lines.
C--
      CALL IXXXXX(PV(0,1),AMSE,IHEL(1),+1,EIN)
      CALL OXXXXX(PV(0,2),AMSE,IHEL(2),-1,EOT)
      CALL OXXXXX(PV(0,3),AMST,IHEL(3),+1,TOT)
      CALL IXXXXX(PV(0,4),AMST,IHEL(4),-1,TIN)
C--
C  Calculate amplitude**2.
C  AMPTTP outputs
C     AMP(0) = AMP(1) + AMP(2)
C        (1) = v_t part
C        (2) = a_t part.
C--
      CALL AMPTTP(GAL,GAU,GZL,GZU,AMSZ,GAMZ,EIN,EOT,TIN,TOT,AMP)
      FACT    = COLOR
      AMP2(0) = FACT*ABS(AMP(1)+AMP(2))**2
      AMP2(1) = FACT*ABS(AMP(1))**2
      AMP2(2) = FACT*ABS(AMP(2))**2
C--
C  That's it.
C--
      RETURN
      END
