CINCLUDE SGZZNP
CINCLUDE AMPZZ
CINCLUDE UHCUPL
C*  Total cross section for e+e- --> ZZ.
C*    RS = sqrt(s)
C*
      DATA LOUNIT / 20 /
C--
C  Differential cross section.
C--
      WRITE(LOUNIT,'(''SET FONT DUPLEX'')')
      WRITE(LOUNIT,'(''NEW FRAME'')')
      WRITE(LOUNIT,'(''SET WINDOW X 2 12 Y 1.8 9.2'')')
      WRITE(LOUNIT,'(''SET LIMITS X 100. 1000.0 Y 0.001 10.'')')
      WRITE(LOUNIT,'(''SET SCALE Y LOGARITHMIC'')')
      WRITE(LOUNIT,'(''SET LABELS SIZE 2.5'')')
      WRITE(LOUNIT,'(''SET TITLE  SIZE 3.0'')')
      WRITE(LOUNIT,'(''TITLE   8. 8.5 SIZE 3.0'',
     .            '' '''' e2+3e2-3 --> ZZ'')')
      WRITE(LOUNIT,'(''CASE                   '',
     .            '' ''''  X X X X        '')')
      WRITE(LOUNIT,'(''TITLE .25 5.0 ANGLE 90 SIZE 4 ''''S0ZZ1(pb)'')')
      WRITE(LOUNIT,'(''CASE                          ''''GX  X    '')')
      WRITE(LOUNIT,'(''TITLE 6.5 0.8 SIZE 4 ''''2s0O (GeV)'')')
      WRITE(LOUNIT,'(''CASE                 ''''M UD      '')')
      WRITE(LOUNIT,'(''SET ORDER X Y'')')
C--
      AMZ  = 91.17
      RSMN =  2*AMZ + 0.1
      NRS  =  100
      NY   =  100
      DO 100 IRS = 0, NRS
         IF ( IRS.LE.20 ) THEN
            DRS  = 1
         ELSE
            RSMN = 5
            DRS  = 10
         ENDIF
         RS = RSMN + IRS*DRS
         BT   = SQRT((1-2*AMZ/RS)*(1+2*AMZ/RS))
         YMN  = -LOG((1+BT)/(1-BT))/2/BT
         YMX  = -YMN
         DY   = (YMX-YMN)/NY
         SGT = 0
         DO 10 IY = 0, NY
            Y = YMN + IY*DY
            IF ( IY.EQ.0 .OR. IY.EQ.NY ) THEN
               WT = 1
            ELSE IF ( MOD(IY,2).EQ.0 ) THEN
               WT = 2
            ELSE
               WT = 4
            ENDIF
            EX  = EXP(2*BT*Y)
            CS  = (EX-1)/(EX+1)/BT
            CALL SGZZNP(RS,CS,SG)
            SGT = SGT + WT*(1-BT*CS)*(1+BT*CS)*SG
10       CONTINUE
         SGT = SGT*DY/3
         SGT = SGT/2
         WRITE(LOUNIT,'(2F15.5)') RS, SGT
100   CONTINUE
      WRITE(LOUNIT,'(''JOIN'')')
C--
      STOP
      END
C*  Differential cross section for e+e- --> ZZ.
C*    RS = sqrt(S)
C*    Y  = cos(theta)
C*
      DATA LOUNIT / 20 /
C--
C  Differential cross section.
C--
      WRITE(LOUNIT,'(''SET FONT DUPLEX'')')
      WRITE(LOUNIT,'(''NEW FRAME'')')
      WRITE(LOUNIT,'(''SET WINDOW X 2 10 Y 2 8'')')
      WRITE(LOUNIT,'(''SET LIMITS X -1. 1.0 Y 0.001 10.'')')
C     WRITE(LOUNIT,'(''SET LIMITS X 0.899 1.01 Y 0.1 100.'')')
      WRITE(LOUNIT,'(''SET SCALE Y LOGARITHMIC'')')
      WRITE(LOUNIT,'(''SET LABELS SIZE 3.0'')')
      WRITE(LOUNIT,'(''SET TITLE  SIZE 3.0'')')
      WRITE(LOUNIT,'(''TITLE   6. 7.5 SIZE 2.5'',
     .            '' '''' e2+3e2-3 --> ZZ'')')
      WRITE(LOUNIT,'(''CASE                   '',
     .            '' ''''  X X X X        '')')
      WRITE(LOUNIT,'(''TITLE 5.7 1.2 ''''cosQ'')')
      WRITE(LOUNIT,'(''CASE          ''''   G'')')
      WRITE(LOUNIT,'(''TITLE 0.2 3.7 ANGLE 90.'',
     .                            '' ''''dS/dcosQ (pb)'')')
      WRITE(LOUNIT,'(''CASE          '''' G     G     '')')
      WRITE(LOUNIT,'(''SET ORDER X Y'')')
C--
      NY   = 1000
C     YMN  = 0.9
C     YMX  = 1.0
      YMN  = -1.
      YMX  =  1.
      DY   = (YMX-YMN)/NY
      RSMN =  200.
      RSMX = 1000.
      NRS  =   8
      DRS  = (RSMX-RSMN)/NRS
      DO 100 IRS = 0, NRS
         RS = RSMN + IRS*DRS
         SGT = 0
         DO 10 IY = 0, NY
            Y = YMN + IY*DY
            IF ( IY.EQ.0 .OR. IY.EQ.NY ) THEN
               WT = 1
            ELSE IF ( MOD(IY,2).EQ.0 ) THEN
               WT = 2
            ELSE
               WT = 4
            ENDIF
            CALL SGZZNP(RS,Y,SG)
            WRITE(LOUNIT,'(2F15.5)') Y, SG
C           PRINT *,  Y, SG
            SGT = SGT + WT*SG
10       CONTINUE
         SGT = SGT*DY/3
         SGT = SGT/2
         PRINT *, ' RS = ', RS, '(GeV)  SGT = ', SGT, '(pb)'
         WRITE(LOUNIT,'(''JOIN'')')
100   CONTINUE
C--
      STOP
      END
